         TITLE     TRI_TV3.ASM   (modes VGA compatibles TV)
                   ;(C) Herv BENOIT 1994 
                   ;ce programme dtourne la fonction 0 de int 10h
                   ;pour configurer en mode TV les cartes VGA et
                   ;S-VGA TRIDENT (modes 0F  12 entrelacs).
                   ;Les modes 00/01, 04/05 et 0D sont incompatibles
                   ;avec une VGA de base et les autres cartes S-VGA.
                   ;La table de paramtres varie selon la rsolution
                   ;choisie et se trouve  la fin.
                   ;Modifie (dtourne) int 10h.
         ;------------------------------------------------------------ 
         code      SEGMENT
                   ORG  100h
                   ASSUME    cs:code;ds:code
         ;------------------------------------------------------------
         debut:    jmp  instal                   ;instal. part. rsidente
         ;------------------------------------------------------------
         sauvedep  dw   ?                        ;offs int10h origine
         sauveseg  dw   ?                        ;segm     "    "
         ;-------------------------------------------------------------
         prg:      cmp ah,0                 ;int10h mod: chgt de mode?
                   je suite                 ;si oui, traitement TV 
         prg2:     jmp dword ptr cs:sauvedep     ;sinon, int 10h orig.
         suite:    pushf                         ;prpa appel inter
                   call dword ptr cs:sauvedep    ;appel int 10h orig.
         ;----------retour de l'inter 10h origine---------------------- 
                   cli                      ;inhib. interrupt
                   pushf                    ;sauve flags & registres
                   push ax                  ;
                   push bx                  ;
                   push dx                  ;
                   push si                  ;
                   push ds                  ;
                   mov ax,40h               ;segment mode video
                   mov ds,ax                ;segment =40h
                   mov al,ds:49h            ;mode (40:49) dans ax
                   xor bx,bx                ;
                   mov bl,al                ;mode dans BX 
                   mov ax,cs                ;ds=cs=code segment
                   mov ds,ax                ;
                   cmp bx, 5Dh              ;mode trident 640x480x256?
                   jne normal               ;sinon, cas courant
                   mov bx, 0Fh              ;si mode 5D, bx=0Fh (14h-05h)
                   jmp continue             ;on adresse pos. table 0Fh
         normal:   cmp bx, 13h              ;mode > 13h ?
                   jg sortie                ;mode illgal,on sort
                   cmp bx, 07h              ;
                   jle continue             ;modes 0  7: pas de problme
                   cmp bx, 0Dh              ;
                   jl  sortie               ;modes 8  OC interdits
                   sub bx, 05h              ;modes 0D  13, table=mode#-5 
         continue: mov cl, 5                ;CL= nombre de dcalages 
                   shl bx, cl               ;BX= offset dans table
                   call CRTC                ;programmation registres
                   mov ax,40h
                   mov ds,ax
                   mov al, byte ptr ds:49h  ;rcup mode video actuel=al
                   cmp al, 07h
                   jg sortie                ;si mode actuel >7, rien
                   je car8                  ;si = 7, caract 8x8
                   cmp al, 03h              ;
                   jg sortie                ;si <=3, caract 8x8
         car8:     call gencur              ;appel gn 8x8 et curseur
         sortie:   pop ds                   ;rcup registres & flags
                   pop si                   ;
                   pop dx                   ;
                   pop bx                   ;
                   pop ax                   ;
                   popf                     ;
                   sti                      ;revalid. interrupt.
                   iret                     ;fin int10h mod
         ;-------------------------------------------------------------
         CRTC:     mov dx, 03C4h            ;sequencer index register
                   mov al, 01h              ;clocking mode register
                   out dx, al               ;
                   inc dx                   ;sequencer data register
                   in al, dx                ;lecture tat courant
                   or al, 09h               ;Fclock/2, 8 dots/chr
                   out dx, al               ;
                   mov dx, 03CCh            ;lecture misc. out. reg.
                   in al, dx                ;
                   or al, 0C4h              ;choix sync. pol et clock
                   and al, 77h              ;V+, H-, 28MHz 
                   mov dx, 03C2h            ;criture misc. out. reg.
                   out dx, al               ;(AL= config Misc Out Reg)
         CRTC2:    mov dx, 03D4h            ;CRTC index register (couleur)
                   and al, 01h              ;teste b1 de misc out reg
                   jnz couleur              ;si b1<>1, couleur
                   mov dx, 03B4h            ;CRTC index (mono) 
         couleur:  mov al, 11h              ;Vretrace end register
                   out dx, al               ;
                   inc dx                   ;CRTC data register
                   in al, dx                ;lecture tat courant
                   and al, 7Fh              ;dprotect. crit. R0-R7
                   out dx, al               ;
                   xor ax, ax               ;ax=0
                   mov si, ax               ;initialisation si
                   dec dx                   ;dx=3D4 (CRTC index)
         loop:     mov ah, [cs:param+bx+si] ;lecture paramtres
                   out dx, ax               ;al=index, ah=donne
                   inc ax                   ;index suivant
                   inc si                   ;paramtre suivant
                   cmp si, 1Eh              ;dernier paramtre?
                   jle loop                 ;si NON, au suivant
         ;---------PARTIE SPECIFIQUE MODES 320 POINTS TRIDENT----------
                   mov dx, 03C4h            ;sequencer
                   mov al, 0Dh              ;registre diviseur TRIDENT
                   out dx, al
                   inc dx
                   mov al,[cs:param+bx+31]  ;rcup. diviseur (31=1Fh)
                   out dx, al
                   ret
         ;-------------------------------------------------------------- 
         gencur:   push ax
                   push bx
                   push cx
                   mov ax, 1102h            ;fonct 11 int10h, chr 8x8.
                   mov bl, 00h              ;genrateur en pos. 0
                   int 10h
                   mov cx, 0705h            ;rtablit taille curseur
                   mov ah, 01h
                   int 10h
                   pop cx
                   pop bx
                   pop ax
                   ret
         ;------------------------------------------------------------
         param     db 34h,27h,28h,95h,2Eh,0B2h,36h,11h     ;mode 0
                   db 00h,47h,06h,07h,00h,00h,00h,00h
                   db 0FBh,05h,0C7h,14h,1Fh,0DAh,0FFh,0A3h
                   db 0FFh,00h,00h,00h,00h,00h,00h,02h
                   
                   db 34h,27h,28h,95h,2Eh,0B2h,36h,11h     ;mode 1
                   db 00h,47h,06h,07h,00h,00h,00h,00h
                   db 0FBh,05h,0C7h,14h,1Fh,0DAh,0FFh,0A3h
                   db 0FFh,00h,00h,00h,00h,00h,00h,02h
         
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,11h      ;mode 2
                   db 00h,47h,06h,07h,00h,00h,00h,00h
                   db 0F9h,8Bh,0C7h,28h,1Fh,0F7h,0FFh,0A3h
                   db 0FFh,00h,00h,00h,00h,00h,00h,00h
         
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,11h      ;mode 3
                   db 00h,47h,06h,07h,00h,00h,00h,00h
                   db 0F9h,8Bh,0C7h,28h,1Fh,0F7h,0FFh,0A3h
                   db 0FFh,00h,00h,00h,00h,00h,00h,00h
         
                   db 34h,27h,28h,95h,2Eh,92h,36h,11h      ;mode 4
                   db 00h,41h,00h,00h,00h,00h,00h,00h
                   db 0FBh,05h,0C7h,14h,00h,0DAh,0E6h,0A2h
                   db 0FFh,00h,00h,00h,00h,00h,00h,02h
                   
                   db 34h,27h,28h,95h,2Eh,92h,36h,11h      ;mode 5
                   db 00h,41h,00h,00h,00h,00h,00h,00h
                   db 0FBh,05h,0C7h,14h,00h,0DAh,0E6h,0A2h
                   db 0FFh,00h,00h,00h,00h,00h,00h,02h
         
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,11h      ;mode 6
                   db 00h,41h,00h,00h,00h,00h,00h,00h
                   db 0F9h,8Bh,0C7h,28h,1Fh,0F0h,36h,0C2h
                   db 0FFh,00h,00h,00h,00h,00h,00h,00h
         
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,11h      ;mode 7
                   db 00h,47h,06h,07h,00h,00h,00h,00h
                   db 0F9h,8Bh,0C7h,28h,1Fh,0F7h,0FFh,0A3h
                   db 0FFh,00h,00h,00h,00h,00h,00h,00h
         
                   db 34h,27h,28h,95h,2Eh,92h,36h,11h      ;mode 0D
                   db 00h,40h,00h,00h,00h,00h,00h,00h
                   db 0FBh,05h,0C7h,14h,00h,0DAh,0E6h,0E3h
                   db 0FFh,00h,00h,00h,00h,00h,00h,02h
                   
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,11h      ;mode 0E
                   db 00h,40h,00h,00h,00h,00h,00h,00h
                   db 0F9h,8Bh,0C7h,28h,1Fh,0F0h,36h,0E3h
                   db 0FFh,00h,00h,00h,00h,00h,00h,00h
         
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,11h      ;mode 0F
                   db 00h,40h,00h,00h,00h,00h,00h,00h
                   db 0F9h,8Bh,0AFh,50h,00h,0B0h,36h,0E3h
                   db 0FFh,00h,00h,00h,00h,00h,04h,00h
         
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,11h      ;mode 10
                   db 00h,40h,00h,00h,00h,00h,00h,00h
                   db 0F9h,8Bh,0AFh,50h,00h,0B0h,36h,0E3h
                   db 0FFh,00h,00h,00h,00h,00h,04h,00h
         
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,15h      ;mode 11
                   db 00h,40h,00h,00h,00h,00h,00h,00h
                   db 0Ch,8Eh,0EFh,50h,00h,0F0h,36h,0E3h 
                   db 0FFh,00h,00h,00h,00h,00h,04h,00h
         
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,15h      ;mode 12
                   db 00h,40h,00h,00h,00h,00h,00h,00h
                   db 0Ch,8Eh,0EFh,50h,00h,0F0h,36h,0E3h
                   db 0FFh,00h,00h,00h,00h,00h,04h,00h
         
                   db 6Ch,4Fh,50h,8Bh,59h,82h,37h,11h      ;mode 13
                   db 00h,40h,00h,00h,00h,00h,00h,00h
                   db 0F9h,8Bh,0C7h,28h,40h,0F0h,36h,0A3h
                   db 0FFh,00h,00h,00h,00h,00h,00h,00h
         
                   db 0DDh,9Fh,0A0h,9Ch,0B3h,9Fh,37h,15h   ;mode 5D
                   db 00h,40h,00h,00h,00h,00h,00h,00h
                   db 08h,8Ah,0EFh,0A0h,40h,0F0h,36h,0E3h
                   db 0FFh,00h,00h,00h,00h,00h,84h,00h
         
         message   db 'Mode TV TRIDENT install (C) H. BENOIT 1994$'
         ;------------------------------------------------------------
         ;----------fin de partie rsidente et installation-----------
         ;------------------------------------------------------------
         instal:   mov  ax,3510h                 ;fonction 35h de int 21h
                   int  21h                      ;vect int 10h orig =ES:BX
                   mov  ax,bx                    ;
                   mov  word ptr ds:sauvedep,ax  ;sauve offset inter orig
                   mov  ax,es                    ;
                   mov  word ptr ds:sauveseg,ax  ;sauve segment inter orig
                   mov  ax,offset prg            ;nouvelle adresse int10h
                   mov  dx,ax
                   mov  ax,2510h                 ;fonction 25h de int 21h
                   int  21h                      ;modifie vecteur int 10h
                   mov bx, 60h                   ;BX= offs. table mode 03
                   call CRTC                     ;registres en mode TV 
                   call gencur                   ;gene 8x8 et curseur
                   lea dx,message                ;chargement message
                   mov  ah,9h                    ;fonction 9h de int 21h
                   int  21h                      ;affichage
                   mov  dx,offset instal         ;protection part. rsid.
                   int  27h                      ;retour  DOS (TSR)
         ;-------------------------------------------------------------
         code      ENDS
         END       debut
         
         
         
NW
K
